diff --git a/core/src/aos_shell.c b/core/src/aos_shell.c
index 2fb9cb4..d3974e4 100644
--- a/core/src/aos_shell.c
+++ b/core/src/aos_shell.c
@@ -1007,208 +1518,255 @@ static int _readChannel(aos_shell_t* shell, AosShellChannel* channel, bool* exec
         // reprint the prompt and line if any matches have been found
         if (matches > 0) {
           _printPrompt(shell);
-          _printLine(shell, 0, shell->inputdata.lineend);
-          _moveCursor(shell, shell->inputdata.lineend, shell->inputdata.cursorpos);
-          shell->inputdata.noinput = false;
+          _printString(shell, line, 0, rdata->input.length);
+          _moveCursor(shell, line, rdata->input.length, rdata->input.cursorpos);
         }
         break;
       }
 
-      case AOS_SHELL_ACTION_INSERTTOGGLE:
+      case ACTION_EXECUTE:
       {
-        if (shell->config & AOS_SHELL_CONFIG_INPUT_OVERWRITE) {
-          shell->config &= ~AOS_SHELL_CONFIG_INPUT_OVERWRITE;
-        } else {
-          shell->config |= AOS_SHELL_CONFIG_INPUT_OVERWRITE;
+        // if the input buffer can hold historic entries
+        if (shell->input.nentries > 1) {
+          _prepare4Modification(shell, rdata);
         }
         break;
       }
 
-      case AOS_SHELL_ACTION_DELETEFORWARD:
+      case ACTION_DELETEBACKWARD:
       {
-        --shell->inputdata.lineend;
-        memmove(&(shell->input.line[shell->inputdata.cursorpos]), &(shell->input.line[shell->inputdata.cursorpos+1]), shell->inputdata.lineend - shell->inputdata.cursorpos);
-        _printLine(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
+        char* line = _prepare4Modification(shell, rdata);
+        --rdata->input.cursorpos;
+        memmove(&line[rdata->input.cursorpos], &line[rdata->input.cursorpos + 1], (rdata->input.length - rdata->input.cursorpos) * sizeof(char));
+        --rdata->input.length;
+        line[rdata->input.length] = '\0';
+        _moveCursor(shell, line, rdata->input.cursorpos + 1, rdata->input.cursorpos);
+        _printString(shell, line, rdata->input.cursorpos, rdata->input.length);
         streamPut(&shell->stream, ' ');
-        _moveCursor(shell, shell->inputdata.lineend + 1, shell->inputdata.cursorpos);
+        _moveCursor(shell, line, rdata->input.length + 1, rdata->input.cursorpos);
         break;
       }
 
-      case AOS_SHELL_ACTION_DELETEBACKWARD:
+      case ACTION_DELETEFORWARD:
       {
-        --shell->inputdata.cursorpos;
-        memmove(&(shell->input.line[shell->inputdata.cursorpos]), &(shell->input.line[shell->inputdata.cursorpos+1]), shell->inputdata.lineend - shell->inputdata.cursorpos);
-        --shell->inputdata.lineend;
-        shell->input.line[shell->inputdata.lineend] = '\0';
-        _moveCursor(shell, shell->inputdata.cursorpos + 1, shell->inputdata.cursorpos);
-        _printLine(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
+        char* line = _prepare4Modification(shell, rdata);
+        --rdata->input.length;
+        memmove(&line[rdata->input.cursorpos], &line[rdata->input.cursorpos + 1], (rdata->input.length - rdata->input.cursorpos) * sizeof(char));
+        _printString(shell, line, rdata->input.cursorpos, rdata->input.length);
         streamPut(&shell->stream, ' ');
-        _moveCursor(shell, shell->inputdata.lineend+1, shell->inputdata.cursorpos);
+        _moveCursor(shell, line, rdata->input.length + 1, rdata->input.cursorpos);
         break;
       }
 
-      case AOS_SHELL_ACTION_RECALLLAST:
+      case ACTION_CLEAR:
       {
-        // replace any intermediate NUL bytes with spaces
-        shell->inputdata.lineend = 0;
-        size_t nul_start = 0;
-        size_t nul_end = 0;
-        // search line for a NUL byte
-        while (nul_start < shell->input.size) {
-          if (shell->input.line[nul_start] == '\0') {
-            nul_end = nul_start + 1;
-            // keep searcjing for a byte that is not NUL
-            while (nul_end < shell->input.size) {
-              if (shell->input.line[nul_end] != '\0') {
-                // an intermediate NUL sequence was found
-                memset(&(shell->input.line[nul_start]), ' ', nul_end - nul_start);
-                shell->inputdata.lineend = nul_end + 1;
-                break;
-              } else {
-                ++nul_end;
-              }
-            }
-            nul_start = nul_end + 1;
-          } else {
-            ++shell->inputdata.lineend;
-            ++nul_start;
-          }
+        // clear visualization
+        _moveCursor(shell, NULL, rdata->input.cursorpos, 0);
+        for (size_t cpos = 0; cpos < rdata->input.length; ++cpos) {
+          streamPut(&shell->stream, ' ');
         }
-        shell->inputdata.cursorpos = shell->inputdata.lineend;
-        // print the line
-        shell->inputdata.noinput = _printLine(shell, 0, shell->inputdata.lineend) == 0;
+        _moveCursor(shell, NULL, rdata->input.length, 0);
+
+        // update metadata
+        rdata->input.cursorpos = 0;
+        rdata->input.length = 0;
+        rdata->buffer.selected = 0;
+
         break;
       }
 
-      case AOS_SHELL_ACTION_CLEAR:
+      case ACTION_RECALLPREVIOUS:
       {
-        // clear output
-        _moveCursor(shell, shell->inputdata.cursorpos, 0);
-        for (shell->inputdata.cursorpos = 0; shell->inputdata.cursorpos < shell->inputdata.lineend; ++shell->inputdata.cursorpos) {
-          streamPut(&shell->stream, ' ');
+        // if the input was cleared but the current entry is occupied by a modified copy of a history entry, skip the current entry
+        if (rdata->buffer.selected == 0 && rdata->buffer.edited > 1) {
+          rdata->buffer.selected += 2;
+        } else {
+          ++rdata->buffer.selected;
         }
-        _moveCursor(shell, shell->inputdata.lineend, 0);
-        shell->inputdata.cursorpos = 0;
-        shell->inputdata.lineend = 0;
-        shell->inputdata.noinput = true;
+        _overwriteOutput(shell, rdata, _getVisualisedEntry(shell, rdata));
+        break;
+      }
+
+      case ACTION_RECALLNEXT:
+      {
+        --rdata->buffer.selected;
+        _overwriteOutput(shell, rdata, _getVisualisedEntry(shell, rdata));
         break;
       }
 
-      case AOS_SHELL_ACTION_CURSOR2START:
+      case ACTION_RECALLOLDEST:
       {
-        _moveCursor(shell, shell->inputdata.cursorpos, 0);
-        shell->inputdata.cursorpos = 0;
+        // find oldest valid entry
+        rdata->buffer.selected = shell->input.nentries;
+        while (_getSelectedEntry(shell, rdata)[0] == INBUF_INIT_CHAR) {
+          --rdata->buffer.selected;
+        }
+
+        _overwriteOutput(shell, rdata, _getVisualisedEntry(shell, rdata));
         break;
       }
 
-      case AOS_SHELL_ACTION_CURSOR2END:
+      case ACTION_RECALLCURRENT:
       {
-        _moveCursor(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
-        shell->inputdata.cursorpos = shell->inputdata.lineend;
+        rdata->buffer.selected = 1;
+        _overwriteOutput(shell, rdata, _getVisualisedEntry(shell, rdata));
         break;
       }
 
-      case AOS_SHELL_ACTION_CURSORLEFT:
+      case ACTION_CURSORLEFT:
       {
-        _moveCursor(shell, shell->inputdata.cursorpos, shell->inputdata.cursorpos-1);
-        --shell->inputdata.cursorpos;
+        _moveCursor(shell, NULL, rdata->input.cursorpos, rdata->input.cursorpos - 1);
+        --rdata->input.cursorpos;
         break;
       }
 
-      case AOS_SHELL_ACTION_CURSORRIGHT:
+      case ACTION_CURSORRIGHT:
       {
-        _moveCursor(shell, shell->inputdata.cursorpos, shell->inputdata.cursorpos+1);
-        ++shell->inputdata.cursorpos;
+        _moveCursor(shell, _getVisualisedEntry(shell, rdata), rdata->input.cursorpos, rdata->input.cursorpos + 1);
+        ++rdata->input.cursorpos;
         break;
       }
 
-      case AOS_SHELL_ACTION_CURSORWORDLEFT:
+      case ACTION_CURSORWORDLEFT:
       {
-        size_t cpos = shell->inputdata.cursorpos;
-        while (cpos > 0 && shell->input.line[cpos-1] == ' ') {
+        // local variables
+        const char* line = _getVisualisedEntry(shell, rdata);
+        size_t cpos = rdata->input.cursorpos;
+
+        // skip spaces
+        while (cpos > 0) {
           --cpos;
+          if (line[cpos] != ' ') {
+            break;
+          }
         }
-        while (cpos > 0 && shell->input.line[cpos-1] != ' ') {
+
+        // search for beginning of the word
+        while (cpos > 0) {
           --cpos;
+          if (line[cpos] == ' ') {
+            // go back to first character of the word
+            ++cpos;
+            break;
+          }
         }
-        _moveCursor(shell, shell->inputdata.cursorpos, cpos);
-        shell->inputdata.cursorpos = cpos;
+
+        // move the cursor and set metadata
+        _moveCursor(shell, line, rdata->input.cursorpos, cpos);
+        rdata->input.cursorpos = cpos;
+
         break;
       }
 
-      case AOS_SHELL_ACTION_CURSORWORDRIGHT:
+      case ACTION_CURSORWORDRIGHT:
       {
-        size_t cpos = shell->inputdata.cursorpos;
-        while (cpos < shell->inputdata.lineend && shell->input.line[cpos] != ' ') {
+        // local variables
+        const char* line = _getVisualisedEntry(shell, rdata);
+        size_t cpos = rdata->input.cursorpos;
+
+        // skip spaces
+        while (cpos < rdata->input.length && line[cpos] == ' ') {
           ++cpos;
         }
-        while (cpos < shell->inputdata.lineend && shell->input.line[cpos] == ' ') {
+
+        // search for end of the word
+        while (cpos < rdata->input.length && line[cpos] != ' ') {
           ++cpos;
         }
-        _moveCursor(shell, shell->inputdata.cursorpos, cpos);
-        shell->inputdata.cursorpos = cpos;
+
+        // move cursor and set metadata
+        _moveCursor(shell, line, rdata->input.cursorpos, cpos);
+        rdata->input.cursorpos = cpos;
+
         break;
       }
 
-      case AOS_SHELL_ACTION_EXECUTE:
+      case ACTION_CURSOR2END:
       {
-        streamPut(&shell->stream, '\n');
-        // if there was some input
-        if (!shell->inputdata.noinput) {
-          // fill the remainder of the line with NUL bytes
-          memset(&(shell->input.line[shell->inputdata.lineend]), '\0', shell->input.size - shell->inputdata.lineend);
-        }
-        // set the execution flag
-        exec = true;
+        _moveCursor(shell, _getVisualisedEntry(shell, rdata), rdata->input.cursorpos, rdata->input.length);
+        rdata->input.cursorpos = rdata->input.length;
         break;
       }
 
-      case AOS_SHELL_ACTION_ESCSTART:
+      case ACTION_CURSOR2START:
       {
-        shell->inputdata.escseq[0] = c;
+        _moveCursor(shell, _getVisualisedEntry(shell, rdata), rdata->input.cursorpos, 0);
+        rdata->input.cursorpos = 0;
         break;
       }
 
-      case AOS_SHELL_ACTION_PRINTUNKNOWNSEQUENCE:
+      case ACTION_RESET:
       {
-        size_t seqc = 1; // element 0 would be unprintible ESC character
-        while (shell->inputdata.escseq[seqc] != '\0') {
-          _readChar(shell, shell->inputdata.escseq[seqc]);
-          ++seqc;
+        // print reset indicator
+        chprintf((BaseSequentialStream*)&shell->stream, "^C");
+        if (!(shell->config & AOS_SHELL_CONFIG_INPUT_OVERWRITE)) {
+          _printString(shell, _getVisualisedEntry(shell, rdata), rdata->input.cursorpos, rdata->input.length);
         }
-        memset(shell->inputdata.escseq, '\0', sizeof(shell->inputdata.escseq)*sizeof(shell->inputdata.escseq[0]));
+        chprintf((BaseSequentialStream*)&shell->stream, "\n");
+
+        // reset buffers and metadata
+        if (rdata->buffer.edited != 0) {
+          memset(_getCurrentEntry(shell, rdata), '\0', shell->input.linewidth * sizeof(char));
+        }
+        rdata->input.length = 0;
+        rdata->input.cursorpos = 0;
+        rdata->buffer.selected = (shell->input.nentries > 1) ? 1 : 0;
+        rdata->buffer.edited = 0;
+
+        // print a new prompt
+        _printPrompt(shell);
+
         break;
       }
 
-      case AOS_SHELL_ACTION_NONE:
+      case ACTION_INSERTTOGGLE:
       {
-        // do nothing (ignore input) and read next byte
-        continue;
+        if (shell->config & AOS_SHELL_CONFIG_INPUT_OVERWRITE) {
+          shell->config &= ~AOS_SHELL_CONFIG_INPUT_OVERWRITE;
+        } else {
+          shell->config |= AOS_SHELL_CONFIG_INPUT_OVERWRITE;
+        }
+        break;
       }
-    } /* end of switch */
 
-    shell->inputdata.lastaction = action;
-  } /* end of while */
+      case ACTION_ESCSTART:
+      {
+        rdata->input.escseq[0] = c;
+        break;
+      }
 
-  // set the execution output flag
-  if (execute) {
-    *execute = exec;
-  }
+      case ACTION_PRINTUNKNOWNSEQUENCE:
+      {
+        _prepare4Modification(shell, rdata);
+        for (size_t seqc = 1; rdata->input.escseq[seqc] != '\0'; ++seqc) {
+          // element 0 would be unprintable ESC character
+          _printChar(shell, rdata, rdata->input.escseq[seqc]);
+        }
+        memset(rdata->input.escseq, '\0', AOS_SHELL_ESCSEQUENCE_LENGTH * sizeof(char));
+        break;
+      }
+    }
 
-  return nchars;
+    // update runtime data
+    rdata->lastaction = (action != ACTION_NONE) ? action : rdata->lastaction;
+  } /* end of while */
+
+  return bytes;
 }
 
 /**
- * @brief   Parses the content of the input buffer (line) to separate arguments.
+ * @brief   Parses the content of the given string to separate arguments.
  *
  * @param[in]   shell   Pointer to the shell object.
+ * @param[in]   str     String to be parsed.
  * @param[out]  argbuf  Buffer to store argument pointers to.
  *
  * @return            Number of arguments found.
  */
-static size_t _parseArguments(aos_shell_t* shell, char** argbuf)
+static size_t _parseArguments(aos_shell_t* shell, char* str, char** argbuf)
 {
   aosDbgCheck(shell != NULL);
+  aosDbgCheck(str != NULL);
   aosDbgCheck(argbuf != NULL);
 
   /*
@@ -1226,15 +1784,15 @@ static size_t _parseArguments(aos_shell_t* shell, char** argbuf)
   size_t nargs = 0;
 
   // iterate through the line
-  for (char* c = shell->input.line; c < shell->input.line + shell->input.size; ++c) {
+  for (size_t c = 0; c < shell->input.linewidth; ++c) {
     // terminate at first NUL byte
-    if (*c == '\0') {
+    if (str[c] == '\0') {
       state = END;
       break;
     }
     // spaces become NUL bytes
-    else if (*c == ' ') {
-      *c = '\0';
+    else if (str[c] == ' ') {
+      str[c] = '\0';
       state = SPACE;
     }
     // handle non-NUL bytes
@@ -1244,7 +1802,7 @@ static size_t _parseArguments(aos_shell_t* shell, char** argbuf)
         case SPACE:
           // ignore too many arguments
           if (nargs < shell->input.nargs) {
-            argbuf[nargs] = c;
+            argbuf[nargs] = &str[c];
           }
           ++nargs;
           break;
@@ -1271,40 +1829,37 @@ static size_t _parseArguments(aos_shell_t* shell, char** argbuf)
 /**
  * @brief   Initializes a shell object with the specified parameters.
  *
- * @param[in] shell         Pointer to the shell object.
- * @param[in] stream        I/O stream to use.
- * @param[in] prompt        Prompt line to print (NULL = use default prompt).
- * @param[in] line          Pointer to the input buffer.
- * @param[in] linesize      Size of the input buffer.
- * @param[in] numargs       Maximum number of arguments (defines size of internal buffer).
- */
-void aosShellInit(aos_shell_t* shell, event_source_t* oseventsource, const char* prompt, char* line, size_t linesize, size_t numargs)
+ * @param[in,out] shell           Pointer to the shell object to be initialized.
+ * @param[in]     prompt          Prompt line to print (NULL = use default prompt).
+ * @param[in]     inbuf           Two dimensional input buffer.
+ * @param[in]     entries         Number of entries in the input buffer (1st dimension).
+ * @param[in]     linewidth       Length of each entry in the input buffer (2nd dimension).
+ * @param[in]     numargs         Maximum number of arguments (defines size of internal buffer).
+ */
+void aosShellInit(aos_shell_t* shell, const char* prompt, char inbuf[], size_t entries, size_t linewidth, size_t numargs)
 {
   aosDbgCheck(shell != NULL);
-  aosDbgCheck(oseventsource != NULL);
-  aosDbgCheck(line != NULL);
+  aosDbgCheck(inbuf != NULL);
+  aosDbgCheck(entries > 0);
+  aosDbgCheck(linewidth > 0);
+  aosDbgCheck(numargs > 0);
 
   // set parameters
   shell->thread = NULL;
   chEvtObjectInit(&shell->eventSource);
-  shell->os.eventSource = oseventsource;
   aosShellStreamInit(&shell->stream);
   shell->prompt = prompt;
   shell->commands = NULL;
   shell->execstatus.command = NULL;
   shell->execstatus.retval = 0;
-  shell->input.line = line;
-  shell->input.length = linesize;
-  shell->input.nargs= numargs;
-  shell->inputdata.lastaction = AOS_SHELL_ACTION_NONE;
-  memset(shell->inputdata.escseq, '\0', sizeof(shell->inputdata.escseq)*sizeof(shell->inputdata.escseq[0]));
-  shell->inputdata.cursorpos = 0;
-  shell->inputdata.lineend = 0;
-  shell->inputdata.noinput = true;
+  shell->input.buffer = inbuf;
+  shell->input.nentries = entries;
+  shell->input.linewidth = linewidth;
+  shell->input.nargs = numargs;
   shell->config = 0x00;
 
   // initialize buffers
-  memset(shell->input.line, '\0', shell->input.length);
+  memset(shell->input.buffer, INBUF_INIT_CHAR, shell->input.nentries * shell->input.linewidth * sizeof(char));
 
   return;
 }
@@ -1604,26 +2159,35 @@ void aosShellChannelOutputDisable(AosShellChannel* channel)
 void aosShellThread(void* shell)
 {
   aosDbgCheck(shell != NULL);
+  aosDbgCheck(((aos_shell_t*)shell)->input.nentries > 0);
 
   // local variables
   eventmask_t eventmask;
   eventflags_t eventflags;
   AosShellChannel* channel;
-  bool execute;
+  runtimedata_t rdata;
   char* args[((aos_shell_t*)shell)->input.nargs];
   size_t nargs = 0;
   aos_shellcommand_t* cmd;
 
-  // initialize variables
+  // initialize variables and buffers
+  rdata.input.length = 0;
+  rdata.input.cursorpos = 0;
+  memset(rdata.input.escseq, '\0', AOS_SHELL_ESCSEQUENCE_LENGTH * sizeof(char));
+  rdata.buffer.current = 0;
+  rdata.buffer.selected = (((aos_shell_t*)shell)->input.nentries > 1) ? 1 : 0;
+  rdata.buffer.edited = 0;
+  rdata.lastaction = ACTION_NONE;
   for (size_t arg = 0; arg < ((aos_shell_t*)shell)->input.nargs; ++arg) {
     args[arg] = NULL;
   }
+  memset(_getCurrentEntry((aos_shell_t*)shell, &rdata), '\0', ((aos_shell_t*)shell)->input.linewidth * sizeof(char));
 
   // register OS related events
-  chEvtRegisterMask(((aos_shell_t*)shell)->os.eventSource, &(((aos_shell_t*)shell)->os.eventListener), AOS_SHELL_EVENTMASK_OS);
+  chEvtRegisterMask(&aos.events.os, &(((aos_shell_t*)shell)->osEventListener), EVENTMASK_OS);
   // register events to all input channels
   for (channel = ((aos_shell_t*)shell)->stream.channel; channel != NULL; channel = channel->next) {
-    chEvtRegisterMaskWithFlags(&(channel->asyncchannel->event), &(channel->listener), AOS_SHELL_EVENTMASK_INPUT, channel->listener.wflags);
+    chEvtRegisterMaskWithFlags(&(channel->asyncchannel->event), &(channel->listener), EVENTMASK_INPUT, channel->listener.wflags);
   }
 
   // fire start event
@@ -1641,9 +2205,9 @@ void aosShellThread(void* shell)
     switch (eventmask) {
 
       // OS related events
-      case AOS_SHELL_EVENTMASK_OS:
+      case EVENTMASK_OS:
       {
-        eventflags = chEvtGetAndClearFlags(&((aos_shell_t*)shell)->os.eventListener);
+        eventflags = chEvtGetAndClearFlags(&((aos_shell_t*)shell)->osEventListener);
         // handle shutdown/restart events
         if (eventflags & AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_MASK) {
           chThdTerminate(((aos_shell_t*)shell)->thread);
@@ -1655,7 +2219,7 @@ void aosShellThread(void* shell)
       }
 
       // input events
-      case AOS_SHELL_EVENTMASK_INPUT:
+      case EVENTMASK_INPUT:
       {
         // check and handle all channels
         channel = ((aos_shell_t*)shell)->stream.channel;
@@ -1663,46 +2227,82 @@ void aosShellThread(void* shell)
           eventflags = chEvtGetAndClearFlags(&channel->listener);
           // if there is new input and a command shall be executed
           if (eventflags & CHN_INPUT_AVAILABLE) {
-            _readChannel((aos_shell_t*)shell, channel, &execute);
-            // an execution request was detected
-            if (execute && !((aos_shell_t*)shell)->inputdata.noinput) {
-              // parse input line to argument list
-              nargs = _parseArguments((aos_shell_t*)shell, args);
-              // check number of arguments
-              if (nargs > ((aos_shell_t*)shell)->input.nargs) {
-                // error too many arguments
-                chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "\ttoo many arguments\n");
-              } else if (nargs > 0) {
-                // search command list for arg[0] and execute callback
-                cmd = ((aos_shell_t*)shell)->commands;
-                while (cmd != NULL) {
-                  if (strcmp(args[0], cmd->name) == 0) {
-                    ((aos_shell_t*)shell)->execstatus.command = cmd;
-                    chEvtBroadcastFlags(&(((aos_shell_t*)shell)->eventSource), AOS_SHELL_EVTFLAG_EXEC);
-                    ((aos_shell_t*)shell)->execstatus.retval = cmd->callback((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, (int)nargs, args);
-                    chEvtBroadcastFlags(&(((aos_shell_t*)shell)->eventSource), AOS_SHELL_EVTFLAG_DONE);
-                    // notify if the command was not successful
-                    if (((aos_shell_t*)shell)->execstatus.retval != 0) {
-                      chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "command returned exit status %d\n", ((aos_shell_t*)shell)->execstatus.retval);
+            _readChannel(shell, &rdata, channel);
+
+            // if an execution request was detected
+            if (rdata.lastaction == ACTION_EXECUTE) {
+              streamPut(&((aos_shell_t*)shell)->stream, '\n');
+              char* line = _getVisualisedEntry((aos_shell_t*)shell, &rdata);
+
+              // skip, if there is nothing to be executed
+              if (line) {
+                // parse arguments
+                nargs = _parseArguments(shell, line, args);
+                // check number of arguments found
+                if (nargs > ((aos_shell_t*)shell)->input.nargs) {
+                  chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "\ttoo many arguments\n");
+                } else if (nargs > 0) {
+                  // search command list for arg[0] and execute callback
+                  cmd = ((aos_shell_t*)shell)->commands;
+                  while (cmd != NULL) {
+                    // if the requested command has been found
+                    if (strcmp(args[0], cmd->name) == 0) {
+                      ((aos_shell_t*)shell)->execstatus.command = cmd;
+                      chEvtBroadcastFlags(&((aos_shell_t*)shell)->eventSource, AOS_SHELL_EVTFLAG_EXECUTE);
+                      ((aos_shell_t*)shell)->execstatus.retval = cmd->callback((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, (int)nargs, args);
+                      chEvtBroadcastFlags(&((aos_shell_t*)shell)->eventSource, AOS_SHELL_EVTFLAG_DONE);
+                      // notify user if execution of the command was not successful
+                      if (((aos_shell_t*)shell)->execstatus.retval != 0) {
+                        chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "command returned exit status %d\n", ((aos_shell_t*)shell)->execstatus.retval);
+                      }
+                      break;
+                    }
+                    // keep searching
+                    else {
+                      cmd = cmd->next;
                     }
-                    break;
+                  } /* end of while */
+
+                  // if no matching command was found, print a message
+                  if (cmd == NULL) {
+                    chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "\tcommand '%s' not found\n", args[0]);
                   }
-                  cmd = cmd->next;
-                } /* end of while */
+                }
 
-                // if no matching command was found, print an error
-                if (cmd == NULL) {
-                  chprintf((BaseSequentialStream*)&((aos_shell_t*)shell)->stream, "\tcommand '%s' not found\n", args[0]);
+                // restore spaces in the current entry, which have been modified to NUL bytes due to argument parsing
+                _restoreWhitespace(line, rdata.input.length);
+
+                // update internat variables
+                {
+                  rdata.input.length = 0;
+                  rdata.input.cursorpos = 0;
+                  rdata.buffer.edited = 0;
+
+                  // if the input buffer can hold historic entries
+                  if (((aos_shell_t*)shell)->input.nentries > 1) {
+                    // iterate in the history only if
+                    // there was some valid input and
+                    // the user did not execute the exact previous command again
+                    if (nargs > 0 &&
+                        strcmp(line, _getRelativeEntry((aos_shell_t*)shell, &rdata, 1)) != 0) {
+                      rdata.buffer.current = (rdata.buffer.current + 1) % ((aos_shell_t*)shell)->input.nentries;
+                    }
+                    // clear and select next (now current) entry
+                    memset(_getCurrentEntry((aos_shell_t*)shell, &rdata), '\0', ((aos_shell_t*)shell)->input.linewidth * sizeof(char));
+                    rdata.buffer.selected = 1;
+                  }
+                  // if there is only a single entry in the input buffer
+                  else {
+                    // do not clear/reset the entry, but start off with a cleared preview
+                    rdata.buffer.selected = 0;
+                  }
                 }
               }
-            }
 
-            // reset some internal variables and print a new prompt
-            if (execute && !chThdShouldTerminateX()) {
-              ((aos_shell_t*)shell)->inputdata.cursorpos = 0;
-              ((aos_shell_t*)shell)->inputdata.lineend = 0;
-              ((aos_shell_t*)shell)->inputdata.noinput = true;
-              _printPrompt((aos_shell_t*)shell);
+              // print a new prompt
+              if (!chThdShouldTerminateX()) {
+                _printPrompt((aos_shell_t*)shell);
+              }
             }
           }
 
diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index 038f3a4..f26497b 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -55,6 +55,15 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define SYSTEM_INFO_NAMEWIDTH         20
 
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
+
+/**
+ * @brief   Number of entries in the system shell input buffer.
+ */
+#define SYSTEM_SHELL_BUFFERENTRIES    (1 + AMIROOS_CFG_SHELL_HISTLENGTH)
+
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
+
 /******************************************************************************/
 /* EXPORTED VARIABLES                                                         */
 /******************************************************************************/
@@ -109,7 +118,7 @@ static THD_WORKING_AREA(_shell_wa, AMIROOS_CFG_SHELL_STACKSIZE);
 /**
  * @brief   Shell input buffer.
  */
-static char _shell_line[AMIROOS_CFG_SHELL_LINEWIDTH];
+static char _shell_buffer[SYSTEM_SHELL_BUFFERENTRIES * AMIROOS_CFG_SHELL_LINEWIDTH];
 
 /**
  * @brief   Shell command to retrieve system information.
@@ -507,8 +516,9 @@ static int _shellcmd_infocb(BaseSequentialStream* stream, int argc, char* argv[]
   // print shell info
   chprintf(stream, "System shell information:\n");
   chprintf(stream, "\tcommands available:     %u\n", aosShellCountCommands(&aos.shell));
-  chprintf(stream, "\tline width:             %u characters\n", aos.shell.input.length);
+  chprintf(stream, "\tinput width:            %u characters\n", aos.shell.input.linewidth);
   chprintf(stream, "\tmaximum arguments:      %u\n", aos.shell.input.nargs);
+  chprintf(stream, "\thistory size:           %u\n", aos.shell.input.nentries - 1);
 #if (AMIROOS_CFG_DBG == true)
   chprintf(stream, "\tthread stack size:      %u bytes\n", aosThdGetStacksize(aos.shell.thread));
 #if (CH_DBG_FILL_THREADS == TRUE)
@@ -709,6 +719,8 @@ size_t _numActiveThreads(void)
  */
 void aosSysInit(const char* shellPrompt)
 {
+  aosDbgCheck(shellPrompt != NULL || !AMIROOS_CFG_SHELL_ENABLE);
+
   /* set control thread to maximum priority */
   chThdSetPriority(AOS_THD_CTRLPRIO);
 
@@ -738,9 +750,9 @@ void aosSysInit(const char* shellPrompt)
 
   /* init shell */
   aosShellInit(&aos.shell,
-               &aos.events.os,
                shellPrompt,
-               _shell_line,
+               _shell_buffer,
+               SYSTEM_SHELL_BUFFERENTRIES,
                AMIROOS_CFG_SHELL_LINEWIDTH,
                AMIROOS_CFG_SHELL_MAXARGS);
   // add system commands
diff --git a/modules/DiWheelDrive_1-1/Makefile b/modules/DiWheelDrive_1-1/Makefile
index 1d6f2a7..bdf5c5a 100644
--- a/modules/DiWheelDrive_1-1/Makefile
+++ b/modules/DiWheelDrive_1-1/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
diff --git a/modules/DiWheelDrive_1-1/aosconf.h b/modules/DiWheelDrive_1-1/aosconf.h
index ba96e60..be160f8 100644
--- a/modules/DiWheelDrive_1-1/aosconf.h
+++ b/modules/DiWheelDrive_1-1/aosconf.h
@@ -280,7 +280,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
-  #define AMIROOS_CFG_SHELL_LINEWIDTH           80
+  #define AMIROOS_CFG_SHELL_LINEWIDTH           64
 #else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
 #endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
@@ -294,6 +294,16 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
 #endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
+/**
+ * @brief   Shell number of history entries.
+ * @details A value of 0 disables shell history.
+ */
+#if !defined(OS_CFG_SHELL_HISTLENGTH)
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          3
+#else /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+  #define AMIROOS_CFG_SHELL_HISTLENGTH          OS_CFG_SHELL_HISTLENGTH
+#endif /* !defined(OS_CFG_SHELL_HISTLENGTH) */
+
 /** @} */
 
 #endif /* AOSCONF_H */
diff --git a/modules/DiWheelDrive_1-2/Makefile b/modules/DiWheelDrive_1-2/Makefile
index 09d4038..1ce9164 100644
--- a/modules/DiWheelDrive_1-2/Makefile
+++ b/modules/DiWheelDrive_1-2/Makefile
@@ -35,7 +35,7 @@ endif
 
 # C specific options here (added to USE_OPT).
 ifeq ($(USE_COPT),)
-  USE_COPT = -std=c17
+  USE_COPT = -std=c99 -fshort-enums
 endif
 
 # C++ specific options here (added to USE_OPT).
